UNSAFE MODULE CPUTime;
(* 
  Implements CPUTime for Unix systems.
  
  Created by J. Stolfi on 95-01-29. *)

IMPORT Uresource;

CONST Microsecond = 1.0d-6;

PROCEDURE Now(): T =
  VAR ru: Uresource.struct_rusage;
  BEGIN
    WITH
      rCode = Uresource.getrusage(Uresource.RUSAGE_SELF, ADR(ru))
    DO
      <* ASSERT rCode = 0 *>
      RETURN 
        FLOAT(ru.ru_utime.tv_sec, LONGREAL) +
        FLOAT(ru.ru_utime.tv_usec, LONGREAL) * Microsecond
    END
  END Now;

BEGIN 
END CPUTime.
