INTERFACE ParseMinimizerParams;

IMPORT ParseParams;
IMPORT Minimizer;

CONST Help = 
  " -minimizer { \\\n" &
  "    PrAxis  | \\\n" &
  "    Grad [ RKF4 | Euler ]  | \\\n" & 
  "    Coord [ Brent | JS ] [ budget <num> ] ]";

PROCEDURE Parse(pp: ParseParams.T): Minimizer.T RAISES {ParseParams.Error};
  (*
    Parses an optimization method from the command line parameters.
    Returns it still uninitialized.
    
    This procedure must be called between "pp.beginParsing" and 
    "pp.endParsing". 

    The syntax is described by the "Help" string above. 
    Returns NIL if no "-optimizer" keyword was specified. *)

END ParseMinimizerParams.
