MODULE UniMin;

PROCEDURE ComputeDerivatives (
    u, fu, v, fv, x, fx: LONGREAL; 
    VAR dfx, ddfx, q: LONGREAL
  ) =
  BEGIN
    WITH
      uv = v - u,
      ux = x - u,
      xv = v - x,
      du = xv * (fx - fu),
      dv = ux * (fv - fx)
    DO
      dfx := du*xv + dv*ux;
      ddfx := 2.0d0 * (dv - du);
      q := uv * ux * xv;
      IF q < 0.0d0 THEN
        dfx := -dfx; ddfx := -ddfx; q := -q
      END
    END;
  END ComputeDerivatives;

BEGIN
END UniMin.
